"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.swaggerConfig = void 0;
const core_1 = require("@nestjs/core");
const example_module_1 = require("./example/example.module");
const swagger_1 = require("@nestjs/swagger");
const swaggerConfig = app => {
    const options = new swagger_1.DocumentBuilder()
        .setTitle('CACHE STRATEGIES')
        .setDescription('The CACHE STRATEGIES API description')
        .setVersion('1.0')
        .build();
    const document = swagger_1.SwaggerModule.createDocument(app, options);
    swagger_1.SwaggerModule.setup('docs', app, document);
};
exports.swaggerConfig = swaggerConfig;
async function bootstrap() {
    const app = await core_1.NestFactory.create(example_module_1.ExampleModule);
    (0, exports.swaggerConfig)(app);
    await app.listen(3000);
    console.log('Application is running on: http://localhost:3000');
}
bootstrap();
//# sourceMappingURL=main.js.map